package com.huimv.manager.service.impl;

import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.manager.mapper.DailyTabulateDataDao;
import com.huimv.manager.result.RRException;
import org.springframework.stereotype.Service;
import java.util.Map;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.manager.utils.PageUtils;
import com.huimv.manager.utils.Query;

import com.huimv.manager.entity.DailyTabulateDataEntity;
import com.huimv.manager.service.DailyTabulateDataService;

/**
 * 耳标每日汇总表
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-24 16:29:33
 */
@Service("dailyTabulateDataService")
public class DailyTabulateDataServiceImpl extends ServiceImpl<DailyTabulateDataDao, DailyTabulateDataEntity> implements DailyTabulateDataService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
       String farmCode =(String) params.get("farmCode");
       if (StringUtils.isBlank(farmCode)){
           throw new RRException("牧场未选择");
       }
       String startTime =(String) params.get("startTime");
       String endTime =(String) params.get("endTime");
       String minStockTotal =(String) params.get("minStockTotal");
       String maxStockTotal =(String) params.get("maxStockTotal");
       String minStockNew =(String) params.get("minStockNew");
       String maxStockNew =(String) params.get("maxStockNew");
       String minOfflineNo =(String) params.get("minOfflineNo");
       String maxOfflineNo =(String) params.get("maxOfflineNo");

        QueryWrapper<DailyTabulateDataEntity> wrapper = new QueryWrapper<>();
        wrapper.eq("farm_code",farmCode);

        wrapper.ge(StringUtils.isNotBlank(startTime),"statistic_date",startTime);
        wrapper.le(StringUtils.isNotBlank(startTime),"statistic_date",endTime);

        wrapper.ge(StringUtils.isNotBlank(minStockTotal),"stock_total",minStockTotal);
        wrapper.le(StringUtils.isNotBlank(maxStockTotal),"stock_total",maxStockTotal);

        wrapper.ge(StringUtils.isNotBlank(minStockNew),"stock_new",minStockNew);
        wrapper.le(StringUtils.isNotBlank(maxStockNew),"stock_new",maxStockNew);

        wrapper.ge(StringUtils.isNotBlank(minOfflineNo),"offline_no",minOfflineNo);
        wrapper.le(StringUtils.isNotBlank(maxOfflineNo),"offline_no",maxOfflineNo);


        IPage<DailyTabulateDataEntity> page = this.page(
                new Query<DailyTabulateDataEntity>().getPage(params),
                wrapper
        );

        return new PageUtils(page);
    }

}